此博客链接:
查找和替换模式
题目链接:https://leetcode-cn.com/problems/find-and-replace-pattern/
题目
你有一个单词列表 words 和一个模式 pattern,你想知道 words 中的哪些单词与模式匹配。
如果存在字母的排列 p ,使得将模式中的每个字母 x 替换为 p(x) 之后,我们就得到了所需的单词,那么单词与模式是匹配的。
(回想一下,字母的排列是从字母到字母的双射:每个字母映射到另一个字母,没有两个字母映射到同一个字母。)
返回 words 中与给定模式匹配的单词列表。
你可以按任何顺序返回答案。
示例:
输入:words = ["abc","deq","mee","aqq","dkd","ccc"], pattern = "abb"
输出:["mee","aqq"]
解释:
"mee" 与模式匹配,因为存在排列 {a -> m, b -> e, ...}。
"ccc" 与模式不匹配,因为 {a -> c, b -> c, ...} 不是排列。
因为 a 和 b 映射到同一个字母。
提示:
1 <= words.length <= 50
1 <= pattern.length = words[i].length <= 20
题解
使用两个哈希表,第一个是存放单词到匹配的对应关系,第二个是存储匹配到存储的对应关系。然后判断两者的对应关系是否是相反的。
代码
class Solution { public List<String> findAndReplacePattern(String[] words, String pattern) { List<String> list=new ArrayList(); for(String word:words){ if(word.length()==pattern.length()){ int flag=1; Map<Character,Character> map1=new HashMap(); Map<Character,Character> map2=new HashMap(); for(int i=0;i<word.length();i++) { if(!map1.containsKey(word.charAt(i))) { map1.put(word.charAt(i),pattern.charAt(i)) ; } if(!map2.containsKey(pattern.charAt(i))) { map2.put(pattern.charAt(i),word.charAt(i)) ; } if(map1.get(word.charAt(i))!=pattern.charAt(i)||map2.get(pattern.charAt(i))!=word.charAt(i)) { flag=0; break; } } if(flag==1) { list.add(word); } } } return list; } }
结果
耗时
一开始把第二个Map写成第一个Map,导致两个map比较时出现越界错误,但是一直就是没有发现问题。这是太粗心了。